declare module '@ioc:Adonis/Core/Middleware' {
    import { IocContract } from '@adonisjs/fold';
    import { HttpContextContract } from '@ioc:Adonis/Core/HttpContext';
    export type MiddlewareNode = string | ((ctx: HttpContextContract, next: () => Promise<void>, args?: string[]) => Promise<void>);
    export type ResolvedMiddlewareNode = {
        type: 'function';
        value: Exclude<MiddlewareNode, string>;
        args: string[];
    } | {
        type: 'autoload' | 'binding';
        namespace: string;
        method: string;
        args: string[];
    };
    export interface MiddlewareStoreContract {
        register(middleware: MiddlewareNode[]): this;
        registerNamed(middleware: {
            [alias: string]: MiddlewareNode;
        }): this;
        get(): ResolvedMiddlewareNode[];
        getNamed(name: string): null | ResolvedMiddlewareNode;
        invokeMiddleware(middleware: ResolvedMiddlewareNode, params: [HttpContextContract, () => Promise<void>]): Promise<void>;
    }
    export interface MiddlewareStoreConstructorContract {
        new (container: IocContract): MiddlewareStoreContract;
    }
    const MiddlewareStore: MiddlewareStoreConstructorContract;
    export default MiddlewareStore;
}
