/// <reference path="../../adonis-typings/index.d.ts" />
/// <reference types="node" />
import { Macroable } from 'macroable';
import { RouteNode } from '@ioc:Adonis/Core/Route';
import { IncomingMessage, ServerResponse } from 'http';
import { LoggerContract } from '@ioc:Adonis/Core/Logger';
import { RequestContract } from '@ioc:Adonis/Core/Request';
import { ResponseContract } from '@ioc:Adonis/Core/Response';
import { ServerConfigContract } from '@ioc:Adonis/Core/Server';
import { ProfilerRowContract } from '@ioc:Adonis/Core/Profiler';
import { EncryptionContract } from '@ioc:Adonis/Core/Encryption';
import { HttpContextContract } from '@ioc:Adonis/Core/HttpContext';
export declare class HttpContext extends Macroable implements HttpContextContract {
    request: RequestContract;
    response: ResponseContract;
    logger: LoggerContract;
    profiler: ProfilerRowContract;
    params: any;
    subdomains: any;
    route?: RouteNode;
    protected _macros: {};
    protected _getters: {};
    constructor(request: RequestContract, response: ResponseContract, logger: LoggerContract, profiler: ProfilerRowContract);
    static create(routePattern: string, routeParams: any, logger: LoggerContract, profiler: ProfilerRowContract, encryption: EncryptionContract, req?: IncomingMessage, res?: ServerResponse, serverConfig?: ServerConfigContract): HttpContext;
}
