/// <reference path="../../adonis-typings/index.d.ts" />
/// <reference types="node" />
import { IocContract } from '@adonisjs/fold';
import { Server as HttpsServer } from 'https';
import { LoggerContract } from '@ioc:Adonis/Core/Logger';
import { EncryptionContract } from '@ioc:Adonis/Core/Encryption';
import { IncomingMessage, ServerResponse, Server as HttpServer } from 'http';
import { ProfilerContract } from '@ioc:Adonis/Core/Profiler';
import { ServerContract, ServerConfigContract, ErrorHandlerNode } from '@ioc:Adonis/Core/Server';
import { Hooks } from './Hooks';
import { Router } from '../Router';
import { MiddlewareStore } from '../MiddlewareStore';
export declare class Server implements ServerContract {
    private _container;
    private _logger;
    private _profiler;
    private _encryption;
    private _httpConfig;
    instance?: HttpServer | HttpsServer;
    middleware: MiddlewareStore;
    router: Router;
    hooks: Hooks;
    private _precompiler;
    private _exception;
    private _requestHandler;
    constructor(_container: IocContract, _logger: LoggerContract, _profiler: ProfilerContract, _encryption: EncryptionContract, _httpConfig: ServerConfigContract);
    private _handleRequest;
    private _getProfileRow;
    private _getContext;
    errorHandler(handler: ErrorHandlerNode): this;
    optimize(): void;
    handle(req: IncomingMessage, res: ServerResponse): Promise<void>;
}
